#include <boost/circular_buffer.hpp>
#include <iostream> 

const int MAX_MSG_PACKET_SIZE		= 4012;
struct PACKETMSG 
{
	short nID;
	char Buffer[ MAX_MSG_PACKET_SIZE ];
};

int main()
{
	// http://www.kmonos.net/alang/boost/classes/circular_buffer.html

	const int MAX_KEEPER_MSG_CAPACITY = 3;

	boost::circular_buffer< PACKETMSG > m_MsgContainer(MAX_KEEPER_MSG_CAPACITY);

	std::cout << "1. ڿ ߰" << std::endl;
	PACKETMSG msg1;	msg1.nID = 1;
	m_MsgContainer.push_back( msg1 );

	PACKETMSG msg2;	msg2.nID = 2;
	m_MsgContainer.push_back( msg2 );

	PACKETMSG msg3;	msg3.nID = 3;
	m_MsgContainer.push_back( msg3 );

	std::cout << m_MsgContainer[0].nID << ", " << m_MsgContainer[1].nID << ", " << m_MsgContainer[2].nID << std::endl;


	std::cout << "2. ߰( )" << std::endl;
	PACKETMSG msg4;	msg4.nID = 4;
	m_MsgContainer.push_back( msg4 );

	std::cout << m_MsgContainer[0].nID << ", " << m_MsgContainer[1].nID << ", " << m_MsgContainer[2].nID << std::endl;


	std::cout << "3. (տ)߰" << std::endl;
	PACKETMSG msg5;	msg5.nID = 5;
	m_MsgContainer.push_front( msg5 );

	std::cout << m_MsgContainer[0].nID << ", " << m_MsgContainer[1].nID << ", " << m_MsgContainer[2].nID << std::endl;
	
	
	std::cout << "4. " << std::endl;
	m_MsgContainer.pop_front();
	std::cout << "Msg Count : " << m_MsgContainer.size() << std::endl;

	return 0;
}