#include <iostream>
#include <string>
#include <boost\lexical_cast.hpp>


struct GAMEITEM
{
	GAMEITEM( int nCode, const char* pszName )
	{
		nItemCode = nCode;
		Name = pszName;
	}

	int nItemCode;
	std::string Name;
};

std::ostream& operator<<( std::ostream& os, const GAMEITEM& item )
{
	return os << item.Name << "(" << item.nItemCode << ")";
}

int main()
{
	std::string strNunmber1 = "3456";
	int nNumber1 = boost::lexical_cast<int>(strNunmber1);
	std::cout << strNunmber1 << " => " << nNumber1 << std::endl;


	std::string strNunmber2 = "34.346";
	float nNumber2 = boost::lexical_cast<float>(strNunmber2);
	std::cout << strNunmber2 << " => " << nNumber2 << std::endl;


	int nNumber3 = 33234;
	std::string strNumber3 = boost::lexical_cast<std::string>(nNumber3);
	std::cout << nNumber3 << " => " << strNumber3 << std::endl;


	
	std::string strText = "Hello, KGC 2011";
	try
	{
		int nNumber = boost::lexical_cast<int>(strText);
	}
	catch( const boost::bad_lexical_cast& e )
	{
		std::cout << " : " << strText << " => " << e.what() << std::endl;
	}



	GAMEITEM item( 11, " " );
	std::string strItemDesc = boost::lexical_cast<std::string>(item);
	std::cout << " 11  : " << strItemDesc << std::endl;

	return 0;
}