#include <boost/multi_index/mem_fun.hpp>
#include <boost/multi_index_container.hpp>
#include <boost/multi_index/ordered_index.hpp>
#include <boost/multi_index/identity.hpp>
#include <boost/multi_index/member.hpp>
#include <boost/multi_index/hashed_index.hpp>
#include <boost/multi_index/sequenced_index.hpp> 
#include <boost/multi_index/random_access_index.hpp>

#include <iostream>


const int MAX_PLAYER_COUNT =8;

class STAGE
{
public:
	STAGE() {}
	~STAGE() {}

	void SetStageNumber(const int nNumber) { m_nStageNum = nNumber; }
	int GetStageNumber() { return m_nStageNum; }

	void SetPlayerCount(const int nCount) { m_nPlayerCount = nCount; }
	int GetPlayerCount() { return m_nPlayerCount; }
	
	void SetStageMasterPlayerCID( const int nMasterPlayerCID ) { m_nMasterPlayerCID = nMasterPlayerCID; }
	int GetStageMasterPlayerCID() { return m_nMasterPlayerCID; }

	bool IsEnableEnter(void)
	{
		if( GetPlayerCount() < MAX_PLAYER_COUNT ) { 
			return true;
		}
		return false;
	}

private:
	int m_nStageNum;
	int m_nPlayerCount;
	int m_nMasterPlayerCID;
};

typedef boost::multi_index::sequenced<>									idx_sequence; /// 
typedef boost::multi_index::mem_fun<STAGE, int, &STAGE::GetStageNumber>	idx_unique_number; ///  ȣ 
typedef boost::multi_index::mem_fun<STAGE, int, &STAGE::GetStageMasterPlayerCID>	idx_MaterCID; ///  ÷̾ ڵ 
typedef boost::multi_index::mem_fun<STAGE, bool, &STAGE::IsEnableEnter>	idx_is_enable_enter; ///   
	
// ε Ÿ 
typedef struct indices : public boost::multi_index::indexed_by
	<
		idx_sequence
		, boost::multi_index::hashed_unique<idx_unique_number> 
		, boost::multi_index::hashed_unique<idx_MaterCID> 
		, boost::multi_index::hashed_non_unique<idx_is_enable_enter>  //boost::multi_index::ordered_non_unique<idx_is_enable_enter>
	>
{
	enum
	{
		IDX_SEQUENCE			= 0
		, IDX_UNIQUE_NUMBER		= 1
		, IDX_MASTER_CID		= 2
		, IDX_IS_ENABLE_ENTER	= 3
		, IDX_END		
	};
};

typedef boost::multi_index_container<STAGE *, indices> Container_stage;
typedef Container_stage::iterator iter_stage;
typedef std::pair<iter_stage, bool> pair_stage_result;

int main()
{
	Container_stage Stages;

	std::cout << "1.  1 ߰" << std::endl;
	STAGE* pStage1 = new STAGE;
	pStage1->SetStageNumber(1);
	pStage1->SetStageMasterPlayerCID(11);
	pStage1->SetPlayerCount(3);
	pair_stage_result pairRet = Stages.push_back( pStage1 );
	if( false == pairRet.second ) 
	{
		std::cout << " ȣ 1 ߰ !" << std::endl;
	}

	std::cout << "2.  1 ߰()" << std::endl;
	STAGE* pStage2 = new STAGE;
	pStage2->SetStageNumber(1);
	pairRet = Stages.push_back( pStage2 );
	if( false == pairRet.second ) 
	{
		std::cout << " ȣ 1 ߰ !" << std::endl;
	}

	std::cout << "3.  2 ߰.( 2 ִ ÷̾ 8.Ǯ)" << std::endl;
	pStage2->SetStageNumber(2);
	pStage2->SetStageMasterPlayerCID(12);
	pStage2->SetPlayerCount(MAX_PLAYER_COUNT);
	pairRet = Stages.push_back( pStage2 );
	if( false == pairRet.second ) 
	{
		std::cout << " ȣ 2 ߰ !" << std::endl;
	}


	std::cout << "4.  3 ߰" << std::endl;
	STAGE* pStage3 = new STAGE;
	pStage3->SetStageNumber(3);
	pStage3->SetStageMasterPlayerCID(13);
	pStage3->SetPlayerCount(MAX_PLAYER_COUNT-1);
	pairRet = Stages.push_back( pStage3 );
	if( false == pairRet.second ) 
	{
		std::cout << " ȣ 3 ߰ !" << std::endl;
	}
	
	
	std::cout << "5.  2 ã" << std::endl;
	int nStageNum = 2;
	Container_stage::nth_index<indices::IDX_UNIQUE_NUMBER>::type &indexby = Stages.get<indices::IDX_UNIQUE_NUMBER>();
	Container_stage::nth_index_iterator<indices::IDX_UNIQUE_NUMBER>::type iter = indexby.find(nStageNum);

	if (indexby.end() != iter) 
	{
		std::cout << ((STAGE*)(*iter))->GetStageNumber() << "  ãҴ" << std::endl;
	}
	

	std::cout << "6.  ȣ 11  ã" << std::endl;
	int nFindMasterCID = 11;
	Container_stage::nth_index<indices::IDX_MASTER_CID>::type &indexbyMasterCID = Stages.get<indices::IDX_MASTER_CID>();
	Container_stage::nth_index_iterator<indices::IDX_MASTER_CID>::type iterMasterCID = indexbyMasterCID.find(nFindMasterCID);

	if (indexbyMasterCID.end() != iterMasterCID) 
	{
		std::cout << "CID " << ((STAGE*)(*iterMasterCID))->GetStageMasterPlayerCID() << "   ãҴ" << std::endl;
	}


	std::cout << "7.   ִ  " << std::endl;
	Container_stage::nth_index<indices::IDX_IS_ENABLE_ENTER>::type &indexby2 
					= Stages.get<indices::IDX_IS_ENABLE_ENTER>();

	std::pair<
		Container_stage::nth_index_iterator<indices::IDX_IS_ENABLE_ENTER>::type, 
		Container_stage::nth_index_iterator<indices::IDX_IS_ENABLE_ENTER>::type> 
		pair;

	Container_stage::nth_index_iterator<indices::IDX_IS_ENABLE_ENTER>::type iter2;

	pair = indexby2.equal_range(true);
	for (iter2 = pair.first; iter2 != pair.second; ++iter2)
	{
		std::cout << ((STAGE*)(*iter2))->GetStageNumber() << "  : " << ((STAGE*)(*iter2))->GetPlayerCount() << "" << std::endl;
	}

	
	std::cout << "8.  " << std::endl;
	nStageNum = 2;
	Container_stage::nth_index<indices::IDX_UNIQUE_NUMBER>::type &indexby1 = Stages.get<indices::IDX_UNIQUE_NUMBER>();
	Container_stage::nth_index_iterator<indices::IDX_UNIQUE_NUMBER>::type iter1 = indexby1.find(nStageNum);

	if (indexby1.end() != iter1) 
	{
		std::cout << ((STAGE*)(*iter1))->GetStageNumber() << "  Ѵ" << std::endl;
		indexby1.erase( iter1 );
	}
	return 0;
}